on InitializeDemo
  global gAutoMode, gTeaserMode, gResellerVersion, gAutoDelay, gMainMovieName, gIntroTimeOut, gInteractiveTimeout, gOEMTimeout, gResellerTimeout, gDialogTimeout, gTeaserList, gCurrTeaser, gDialogResult, gAutoTestMode, gScanExitFlag, gNoHelp, gTopicList, gCurrTopic, gLastForwardBlink, gLastTextBox, gLastScreen, gCDROMversion, gLastAudio, gAudioPath, gSectionAnimationSpeed, gNextKey, gBackKey, gMenuKey, gRestartKey, gExitKey, glasttms
  clearGlobals()
  set glasttms to the timeoutScript
  setUpDemo()
  set gAutoTestMode to 0
  set gAutoMode to 0
  set gTeaserMode to 0
  set gMainMovieName to "A95Demo.DIR"
  set gScanExitFlag to 1
  set gLastAudio to EMPTY
  set gTopicList to field "file list"
  set gCurrTopic to 1
  set gTeaserList to field "teaser list"
  set gCurrTeaser to 0
  set gLastForwardBlink to the ticks
  set gDialogResult to EMPTY
  set gLastTextBox to EMPTY
  set gLastScreen to EMPTY
  if the machineType = 256 then
    set the exitLock to 1
  end if
end

on showtimeout
  global glasttms
  if glasttms <> the timeoutScript then
    put the timeoutScript
    put the timeoutLength
    set glasttms to the timeoutScript
  end if
end

on startMovie
  global gMainMovieName, gAutoMode, gResellerVersion, gSwapResExit
  if voidp(gAutoMode) then
    InitializeDemo()
  end if
  if the movie <> gMainMovieName then
    setupTopicMovies()
  end if
end

on setupTopicMovies
  global gResellerVersion, gCurrCPButton, gCPbuttonIndex, gDontHilite, gLastAudio, gSwapResExit
  set gDontHilite to 0
  set gLastAudio to EMPTY
  repeat with x = 23 to 28
    puppetSprite(x, 1)
  end repeat
  if gResellerVersion = 1 then
    set EXRSbutton to 28
  else
    set EXRSbutton to 27
  end if
  set gCurrCPButton to 1
  set gCPbuttonIndex to "24" & RETURN & EXRSbutton & RETURN & "23" & RETURN & "25"
  if gSwapResExit = 1 then
    set the locH of sprite EXRSbutton to 555
    puppetSprite(26, 1)
    set the locH of sprite 26 to -1000
  end if
  updateStage()
end

on chooseInteractive
  global gAutoMode, gResellerTimeout, gOEMTimeout, gResellerVersion
  set the timeoutScript to EMPTY
  set gAutoMode to 0
  if gResellerVersion = 1 then
    resetResellerTimeout()
  else
  end if
  go("p1")
end

on resetResellerTimeout
  global gResellerTimeout
  set the timeoutLength to gResellerTimeout
  set the timeoutScript to "timeOutResellerDialog"
end

on clearTimeout
  set the timeoutScript to EMPTY
  set the timeoutLength to 0
end

on chooseAutoDemo
  global gAutoMode, gTeaserMode
  set the timeoutScript to EMPTY
  set gAutoMode to 1
  set gTeaserMode to 0
  if (the frame - 1) = label("introDialog") then
    clearMenuButtons()
  end if
  go("p1")
end

on startAutoDemo
  set the timeoutScript to EMPTY
  selectSection("full tour")
end

on doIntroAnimation
  clearMenuButtons()
  set the timeoutScript to EMPTY
  set the timeoutLength to 0
  go("introAnimation")
end

on chooseAutoDemoOLD
  global gAutoMode
  set the timeoutScript to EMPTY
  set gAutoMode to 1
  go("blank")
  selectSection("full tour")
end

on chooseTeaserDemo
  global gResellerTimeout, gAutoMode, gTeaserMode, gTeaserList, gCurrTeaser
  set the timeoutScript to EMPTY
  set gAutoMode to 1
  set gTeaserMode to 1
  if (the frame - 1) = label("introDialog") then
    clearMenuButtons()
  end if
  set gCurrTeaser to gCurrTeaser + 1
  if gCurrTeaser > the number of lines in gTeaserList then
    set gCurrTeaser to 1
  end if
  go("p1")
end

on startTeaserDemo
  global gAutoMode, gTeaserMode, gTeaserList, gCurrTeaser
  set teaser to line gCurrTeaser of gTeaserList
  selectSection(teaser)
end

on setSprites default
  global gCurrDialogButton
  set gCurrDialogButton to default
  puppetSprite(2, 1)
  puppetSprite(3, 1)
  if the castNum of sprite 4 <> 0 then
    puppetSprite(4, 1)
  end if
end

on hiliteButton s
  global gDontHilite
  if voidp(s) then
    if gDontHilite = 0 then
      set s to the clickOn
    else
      set gDontHilite to 0
      exit
    end if
  end if
  if the puppet of sprite s = 0 then
    set setPuppet to 1
  else
    set setPuppet to 0
  end if
  set h to the locH of sprite s
  set v to the locV of sprite s
  if setPuppet = 1 then
    puppetSprite(s, 1)
  end if
  set the locH of sprite s to h + 2
  set the locV of sprite s to v + 2
  updateStage()
  wait()
  set the locH of sprite s to h
  set the locV of sprite s to v
  updateStage()
  wait()
  if setPuppet = 1 then
    puppetSprite(s, 0)
  end if
end

on menuTransition
end

on selectSection section
  global gTopicList, gCurrTopic, gCurrSection, gNoHelp
  hiliteButton()
  set gCurrSection to section
  if (gNoHelp = 1) and ((section = "quick tour") or (section = "customizing")) then
    set gTopicList to field (section & " nohelp")
  else
    set gTopicList to field section
  end if
  set gCurrTopic to 1
  hideChecks()
  clearMenuButtons()
  go(1, line gCurrTopic of gTopicList)
end

on goMenu menuNUm
  global gMainMovieName, gCurrSection, gLastScreen, gAutoMode, gResellerVersion
  sound stop 1
  if gAutoMode = 1 then
    AutoDecisionDialog()
    exit
  end if
  if not voidp(menuNUm) then
    hideChecks()
    if (gResellerVersion = 0) and (menuNUm = 1) then
      go("menu1eu", gMainMovieName)
    else
      go("menu" & string(menuNUm))
    end if
    showChecksMenu(menuNUm)
    exit
  end if
  if "dial msn exchange plug system plus office" contains gCurrSection then
    pushLastScreen()
    if the movie = gMainMovieName then
      menuTransition()
      go("menu3")
    else
      menuTransition()
      go("menu3", gMainMovieName)
    end if
    menuTransition()
    showChecksMenu(3)
  else
    pushLastScreen()
    if the movie = gMainMovieName then
      go("menu2")
    else
      go("menu2", gMainMovieName)
    end if
    menuTransition()
    showChecksMenu(2)
  end if
end

on backToLastFrame
  global gLastScreen
  hiliteButton()
  clearMenuButtons()
  set m to gLastScreen
  pushLastScreen()
  if m <> EMPTY then
    if item 2 of m = the movie then
      go(value(item 1 of m))
    else
      go(value(item 1 of m), item 2 of m)
    end if
  end if
end

on pushLastScreen
  global gLastScreen
  set frameNo to marker(0)
  set m to the movie
  if m = "W95Demo.EXE" then
    set m to "A95DEMO.DIR"
  end if
  set gLastScreen to frameNo & "," & m
end

on goBack
  global gTopicList, gCurrTopic, gAutoMode
  sound stop 1
  if gAutoMode = 1 then
    AutoDecisionDialog()
    exit
  end if
  if the frameLabel contains "start" then
    set gCurrTopic to gCurrTopic - 1
    if (gCurrTopic < 1) or (gCurrTopic > the number of lines in gTopicList) then
      goMenu()
    else
      set topic to line gCurrTopic of gTopicList
      go("end", topic)
    end if
  else
    if the frameLabel = "endCoffee" then
      go("coffee")
    else
      go(marker(-1))
      if the frameScript = 451 then
        go(marker(-1))
      end if
    end if
  end if
end

on goNext
  global gTopicList, gCurrTopic, gCurrSection, mouseUp, gLastScreen, gAutoMode, gTeaserMode, gResellerVersion, gAutoDelay, gMainMovieName
  sound stop 1
  if gAutoMode = 1 then
    AutoDecisionDialog()
    exit
  end if
  if the frameLabel = "end" then
    addFinishedTopic(line gCurrTopic of gTopicList)
    set gCurrTopic to gCurrTopic + 1
    if (gCurrTopic < 1) or (gCurrTopic > the number of lines in gTopicList) then
      if gCurrSection = "quick tour" then
        set gLastScreen to the frame & "," & the movie
        go("m3d", gMainMovieName)
      else
        goMenu()
      end if
    else
      set topic to line gCurrTopic of gTopicList
      go(1, topic)
    end if
  else
    go(marker(1))
  end if
end

on addFinishedTopic finishedTopic
  global gFinishedTopics
  if not (gFinishedTopics contains finishedTopic) then
    put finishedTopic & RETURN after gFinishedTopics
  end if
end

on clearMenuButtons
  global gCurrDialogButton
  repeat with s = 9 to 19
    puppetSprite(s, 0)
  end repeat
  puppetSprite(20, 0)
  set gCurrDialogButton to 0
end

on setMenuExitButton s
  global gResellerVersion
  puppetSprite(20, 1)
  if gResellerVersion = 1 then
    set the castNum of sprite s to cast "green restart"
  end if
  set the locH of sprite 20 to -1000
  updateStage()
end

on setDefaultMenuButton sp
  global gCurrDialogButton
  if voidp(gCurrDialogButton) or (gCurrDialogButton = 0) then
    set gCurrDialogButton to 9
    set lastsprite to gCurrDialogButton
    set gCurrDialogButton to sp
    set c to the castNum of sprite lastsprite
    set the castNum of sprite lastsprite to c - 1
    set c to the castNum of sprite gCurrDialogButton
    set the castNum of sprite gCurrDialogButton to c + 1
  end if
end

on showChecksMenu menuNUm
  global gFinishedTopics, gCurrSection
  if voidp(gFinishedTopics) then
    set gFinishedTopics to EMPTY
  end if
  set lastChar to the number of chars in gFinishedTopics
  if char lastChar of gFinishedTopics = RETURN then
    delete char lastChar of gFinishedTopics
  end if
  puppetSprite(41, 1)
  puppetSprite(42, 1)
  puppetSprite(43, 1)
  puppetSprite(44, 1)
  puppetSprite(45, 1)
  puppetSprite(46, 1)
  puppetSprite(47, 1)
  if gFinishedTopics = EMPTY then
  end if
  if gCurrSection <> EMPTY then
  end if
  if menuNUm = 2 then
    if gFinishedTopics contains field "getting" then
      showc(41)
    else
      setDefaultMenuButton(9)
    end if
    if gFinishedTopics contains field "working" then
      showc(42)
    else
      setDefaultMenuButton(10)
    end if
    if gFinishedTopics contains field "organizing" then
      showc(43)
    else
      setDefaultMenuButton(11)
    end if
    if gFinishedTopics contains field "customizing" then
      showc(44)
    else
      setDefaultMenuButton(12)
    end if
  else
    if menuNUm = 3 then
      if gFinishedTopics contains field "dial" then
        showc(41)
      else
        setDefaultMenuButton(9)
      end if
      if gFinishedTopics contains field "exchange" then
        showc(42)
      else
        setDefaultMenuButton(10)
      end if
      if gFinishedTopics contains field "MSN" then
        showc(43)
      else
        setDefaultMenuButton(11)
      end if
      if gFinishedTopics contains field "plug" then
        showc(44)
      else
        setDefaultMenuButton(12)
      end if
      if gFinishedTopics contains field "system" then
        showc(45)
      else
        setDefaultMenuButton(13)
      end if
      if gFinishedTopics contains field "plus" then
        showc(46)
      else
        setDefaultMenuButton(14)
      end if
      if gFinishedTopics contains field "office" then
        showc(47)
      else
        setDefaultMenuButton(15)
      end if
    end if
  end if
  updateStage()
end

on hideChecks
  puppetSprite(41, 0)
  puppetSprite(42, 0)
  puppetSprite(43, 0)
  puppetSprite(44, 0)
  puppetSprite(45, 0)
  puppetSprite(46, 0)
  puppetSprite(47, 0)
  updateStage()
end

on gop2
  go("p2")
end

on goCloser
  global gMainMovieName
  dialogClose()
  go("closer", gMainMovieName)
end

on goScan
  go("endSniff", field "scan movie name")
end

on doEndCloser
  global gAutoMode, gTeaserMode, gResellerVersion, gCDROMversion
  if gResellerVersion = 1 then
    set gAutoMode to 0
    set gTeaserMode to 0
    go("black")
  else
    if (gResellerVersion = 0) and (gCDROMversion = 0) then
      deleteFilesDialog()
    else
      doQuit()
    end if
  end if
end

on goRestart
  global gMainMovieName
  dialogClose()
  puppetSprite(24, 0)
  if the movie = gMainMovieName then
    go("intro1")
  else
    go("intro1", gMainMovieName)
  end if
end

on doDeleteFiles
  if the machineType = 256 then
    doQuit()
  else
    alert("On Windows Machine, Delete Files Here")
  end if
end

on doQuit
  global gMainMovieName
  dialogClose()
  quit()
end

on skipIntro
  set the mouseDownScript to EMPTY
  if the key = "s" then
    go("skip")
  end if
end

on blinkForwardArrow
  global gLastForwardBlink, gCurrCPButton
  if gCurrCPButton = 1 then
    set default to ".dark"
  else
    set default to EMPTY
  end if
  if (the ticks - gLastForwardBlink) > 25 then
    if the castNum of sprite 24 = the number of cast ("next normal" & default) then
      set num to cast ("next blink" & default)
    else
      if the castNum of sprite 24 = the number of cast ("next blink" & default) then
        set num to cast ("next normal" & default)
      end if
    end if
    set the castNum of sprite 24 to num
    updateStage()
    set gLastForwardBlink to the ticks
  end if
end

on showNextBtn
  global gLastForwardBlink, gCurrCPButton
  if gCurrCPButton = 1 then
    set default to ".dark"
  else
    set default to EMPTY
  end if
  if the castNum of sprite 24 <> the number of cast ("next normal" & default) then
    set the castNum of sprite 24 to cast ("next normal" & default)
    updateStage()
  end if
end

on show s
  set x to the locH of sprite s
  if x < 0 then
    set the locH of sprite s to x + 1000
  end if
end

on hide s
  set x to the locH of sprite s
  if x > 0 then
    set the locH of sprite s to x - 1000
  end if
end

on showc s
  set x to the locH of sprite s
  if x < 0 then
    set the locH of sprite s to ((x + 1000) * -1) + 5
  end if
end

on hidec s
  set w to the width of sprite s / 2
  set x to the locH of sprite s
  if x > 0 then
    set the locH of sprite s to ((x + 1000) * -1) - w
  end if
end
